import * as React from "react";
import { calculateRgba, cssValue } from "./helpers";
import { createAnimation } from "./helpers/animation";
var long = createAnimation("BarLoader", "0% {left: -35%;right: 100%} 60% {left: 100%;right: -90%} 100% {left: 100%;right: -90%}", "long");
var short = createAnimation("BarLoader", "0% {left: -200%;right: 100%} 60% {left: 107%;right: -8%} 100% {left: 107%;right: -8%}", "short");
function BarLoader(_a) {
    var _b = _a.loading, loading = _b === void 0 ? true : _b, _c = _a.color, color = _c === void 0 ? "#000000" : _c, _d = _a.speedMultiplier, speedMultiplier = _d === void 0 ? 1 : _d, _e = _a.css, css = _e === void 0 ? {} : _e, _f = _a.height, height = _f === void 0 ? 4 : _f, _g = _a.width, width = _g === void 0 ? 100 : _g;
    var wrapper = function () {
        return Object.assign({
            position: "relative",
            width: cssValue(width),
            height: cssValue(height),
            overflow: "hidden",
            backgroundColor: calculateRgba(color, 0.2),
            backgroundClip: "padding-box"
        }, css);
    };
    var style = function (i) {
        return {
            position: "absolute",
            height: cssValue(height),
            overflow: "hidden",
            backgroundColor: color,
            backgroundClip: "padding-box",
            display: "block",
            borderRadius: 2,
            willChange: "left, right",
            animationFillMode: "forwards",
            animation: (i === 1 ? long : short) + " " + 2.1 / speedMultiplier + "s " + (i === 2 ? 1.15 / speedMultiplier + "s" : "") + " " + (i === 1 ? "cubic-bezier(0.65, 0.815, 0.735, 0.395)" : "cubic-bezier(0.165, 0.84, 0.44, 1)") + " infinite"
        };
    };
    if (!loading) {
        return null;
    }
    return (React.createElement("span", { style: wrapper() },
        React.createElement("span", { style: style(1) }),
        React.createElement("span", { style: style(2) })));
}
export default BarLoader;
